(function ($) {

  var SmartContentManager = Drupal.smart_content.SmartContentManager;

  Drupal.behaviors.decisionAgentClientSide = {
    attach: function (context, settings) {
      SmartContentManager.attach('data-smart-content-client', context);
    }
  };
  SmartContentManager.plugin = SmartContentManager.plugin || {};
  SmartContentManager.plugin.client = SmartContentManager.plugin.client || {};
  SmartContentManager.plugin.client.decisionAgentClientSide = {
    process: function (Decision) {
      if (Decision.processed) {
        return;
      }

      var earlier_variation_not_appeased = false;
      for (var i = 0; i < Decision.variations.length; i++) {
        // If Decision processed, stop further processing.
        if (Decision.processed) {
          return;
        }

        var Variation = Decision.variations[i];
        // If not appeased, loop through conditions and check process status.
        if(!Variation.appeased) {
          Variation.checkAppeased();
        }

        // If after processing conditions, variation still not appeased, restrict later variants from processing Decision.
        if(!Variation.appeased) {
          var earlier_variation_not_appeased = true;
        }
        // Process variation if previous Variations appeased and evaluate false.
        if(Variation.appeased && !Variation.processed && !earlier_variation_not_appeased) {
          Variation.processed = true;

          // Evaluate condition
          Variation.evaluateClientside();

          // Variation.result = Boolean(Math.round(Math.random()));
          if(Variation.result) {
            Decision.processed = true;
            Decision.params = [Decision.name.split(/\.(.+)/)[0], Decision.name.split(/\.(.+)/)[1], Variation.id];
          } else {
            //@todo: check if last variation, handle fallback or set winnder false.
            if(i == (Decision.variations.length - 1)) {
              Decision.processed = true;
              console.log('No winners this time :(');
            }
          }
        }
      }
    },
    execute: function (Decision) {
      if(Decision.params.length === 3) {
        var url = '/ajax/smart-content/decision/' + Decision.params.join('/');
        var ajaxObject = new Drupal.ajax({
          url: url,
          progress: false,
          success: function (response, status) {
            for (var i in response) {
              if (response.hasOwnProperty(i) && response[i].command && this.commands[response[i].command]) {
                this.commands[response[i].command](this, response[i], status);
              }
            }
          }
        });
        ajaxObject.execute();
      }
    }
  };
  SmartContentManager.plugin.Variation = SmartContentManager.plugin.Variation || {};
  SmartContentManager.plugin.Variation.decisionAgentClientSide = {
    init: function (Variation) {
      Variation.processed = false;
      Variation.result = false;
    }
  };

  SmartContentManager.plugin.Condition = SmartContentManager.plugin.Condition || {};
  SmartContentManager.plugin.Condition.decisionAgentClientSide = {
    init: function (Condition) {
      Condition.result = false;
    }
  }
})(jQuery);