<?php

namespace Drupal\smart_content\Condition;

use Drupal\Core\Plugin\DefaultPluginManager;
use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;

/**
 * Provides the Smart condition plugin manager.
 */
class ConditionManager extends DefaultPluginManager {

  //@todo: Add support for broken condition handling.

  /**
   * Constructor for SmartConditionManager objects.
   *
   * @param \Traversable $namespaces
   *   An object that implements \Traversable which contains the root paths
   *   keyed by the corresponding namespace to look for plugin implementations.
   * @param \Drupal\Core\Cache\CacheBackendInterface $cache_backend
   *   Cache backend instance to use.
   * @param \Drupal\Core\Extension\ModuleHandlerInterface $module_handler
   *   The module handler to invoke the alter hook with.
   */
  public function __construct(\Traversable $namespaces, CacheBackendInterface $cache_backend, ModuleHandlerInterface $module_handler) {
    parent::__construct('Plugin/smart_content/Condition', $namespaces, $module_handler, 'Drupal\smart_content\Condition\ConditionInterface', 'Drupal\smart_content\Annotation\SmartCondition');
    $this->alterInfo('smart_content_smart_condition_info');
    $this->setCacheBackend($cache_backend, 'smart_content_smart_condition_plugins');
  }


  //@todo: refactor
  public function getFormOptions($filter = '') {
    $options = [];
    $condition_group_manager = \Drupal::service('plugin.manager.smart_content.condition_group');
    $condition_group_definitions = $condition_group_manager->getDefinitions();
    foreach ($this->getDefinitions() as $plugin_id => $definition) {
      if (isset($condition_group_definitions[$definition['group']])) {
        $label = $condition_group_definitions[$definition['group']]['label'];
        $options[$label->render()][$plugin_id] = $definition['label'];
      }
    }
    return $options;
  }

  public function getInstance(array $options) {
    return parent::getInstance($options);
  }

}
