<?php

namespace Drupal\smart_content\ConditionType;

use Drupal\Component\Plugin\ConfigurablePluginInterface;
use Drupal\Component\Plugin\PluginBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Plugin\PluginFormInterface;
use Drupal\smart_content\ConditionType\ConditionTypeInterface;

/**
 * Base class for Smart condition type plugins.
 */
abstract class ConditionTypeBase extends PluginBase implements ConditionTypeInterface, PluginFormInterface, ConfigurablePluginInterface {

  //  abstract function evaluate();

  /**
   * Returns libraries required for js processing.
   * //@todo: Split clientside and server side library dependencies.
   *
   * @return array
   */
  public function getLibraries() {
    return [];
  }

  /**
   * Returns data required for processing conditions.
   *
   * @return array
   */
  public function getAttachedSettings() {
    return [];
  }

  /**
   * Returns data required for processing conditions on the client side.
   *
   * @return array
   */
  public function getClientAttachedSettings() {
    return $this->getConfiguration();
  }

  /**
   * @inheritdoc
   */
  public function validateConfigurationForm(array &$form, FormStateInterface $form_state) {
  }

  /**
   * @inheritdoc
   */
  public function submitConfigurationForm(array &$form, FormStateInterface $form_state) {
    $this->configuration = $form_state->getValues();
  }

  /**
   * {@inheritdoc}
   */
  public function getConfiguration() {
    return $this->configuration;
  }

  /**
   * {@inheritdoc}
   */
  public function setConfiguration(array $configuration) {
    $this->setConfiguration($configuration + $this->defaultConfiguration());
  }

  /**
   * {@inheritdoc}
   */
  public function defaultConfiguration() {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function calculateDependencies() {
    // TODO: Implement calculateDependencies() method.
  }

}

