<?php

namespace Drupal\smart_content\Controller;

use Drupal\Component\Utility\Html;
use Drupal\Core\Ajax\AjaxResponse;
use Drupal\Core\Ajax\ReplaceCommand;
use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Render\Element\StatusMessages;
use Drupal\smart_content\Entity\SmartVariationSet;
use Drupal\smart_content\Entity\SmartVariationSetInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Drupal\smart_content\Condition\ConditionManager;

/**
 * Class DecisionController.
 *
 * @package Drupal\smart_content\Controller
 */
class DecisionController extends ControllerBase {

  /**
   * Drupal\smart_content\Condition\ConditionManager definition.
   *
   * @var \Drupal\smart_content\Condition\ConditionManager
   */
  protected $pluginManagerSmartContentCondition;

  /**
   * {@inheritdoc}
   */
  public function __construct(ConditionManager $plugin_manager_smart_content_condition) {
    $this->pluginManagerSmartContentCondition = $plugin_manager_smart_content_condition;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('plugin.manager.smart_content.condition')
    );
  }

  /**
   * Server side processing.
   * //@todo: This needs to be completed.
   *
   * @param \Drupal\smart_content\Entity\SmartVariationSetInterface $entity
   *
   * @return \Drupal\Core\Ajax\AjaxResponse
   */
  public function decider(SmartVariationSetInterface $entity) {
    $context = \Drupal::request()->request->get('context');
    parse_str($context, $array);
    //    if(isset($array['data'])) {
    //      $response = $entity->evaluate($array['data']);
    //    }
    return !empty($response) ? $response : new AjaxResponse();;
  }

  /**
   * Client side processing.
   * Returns the winning variation from a client side processed decision.
   *
   * @param \Drupal\smart_content\Entity\SmartVariationSetInterface $entity
   *
   * @param $variation_id
   *
   * @return \Drupal\Core\Ajax\AjaxResponse
   */
  public function reaction(SmartVariationSetInterface $entity, $variation_id) {
    //@todo: add neww validation for variation_id;
    $response = $entity->getVariationResponse($variation_id);
    return !empty($response) ? $response : new AjaxResponse();;
  }

}
